frontend/v1/app/urls.py
from django.conf.urls import url
from .views import *

#url for app
urlpatterns = [
    url(r'^job/listing/', show_jobs, name='job-listing'),
    url(r'^student/list/', show_student, name='student-list'),
    url(r'^job/forum/(?P<id>\d)/$', show_job_forum, name='job-forum'),
    url(r'^job/forum/(?P<id>\d)/post/$', add_comment, name='post-comment'),
    url(r'^job/comment/delete/(?P<id>\d)/$', delete_comment, name='delete-comment'),
	url(r'^student/profile/(?P<pk>.*)/$', show_student_profile, name='student-profile'),
    url(r'^company/logout/', auth_logout, name='company-logout'),
    url(r'^job/forum/(?P<id>\d)/apply/$', add_application, name='apply-job'),
]

frontend/v1/app_company/urls.py
from django.conf.urls import url
from .views import *
#url for app
urlpatterns = [
    url(r'^$', show_profile, name='profile'),
    url(r'^id/(?P<key>.*)/$', show_profile_by_id, name='profile-by-id'),
    url(r'^job/add/$', add_job, name='company-add-job'),
    url(r'^job/delete/(?P<id>\d)/$', delete_job, name='company-delete-job'),
]

frontend/v1/ppw_final/urls.py
from django.conf.urls import url, include, static
from django.contrib import admin
from django.conf import settings
from django.views.generic.base import RedirectView

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^auth/', include('app_auth.urls', namespace='auth')),
    url(r'^company/', include('app_company.urls', namespace='company')),
    url(r'^mahasiswa/', include('app_mahasiswa.urls', namespace='mahasiswa')),
    url(r'^test/', include('app_render.urls', namespace='render')),
    url(r'^app/', include('app.urls', namespace='app')),
    url(r'^$', RedirectView.as_view(url='auth/', permanent = True), name = '$'),
]

frontend/v1/app_company/models.py
from django.db import models
from app_mahasiswa.models import User

class Company(models.Model):
    id_linkedin = models.CharField(primary_key=True, blank=True, max_length=20)

    name = models.CharField(max_length=140)
    company_type = models.CharField(max_length=140)
    web = models.CharField(max_length=140)
    description = models.CharField(max_length=500)
    specialty = models.CharField(max_length=140)

    picture_url = models.CharField(blank=True, max_length=300)
    lastseen_at = models.DateTimeField('Last Seen at', auto_now=True, editable=False)
    created_at = models.DateTimeField('Created at', auto_now_add=True, editable=False)

    def __str__(self):
        return self.name

class Job(models.Model):
    # company = models.ForeignKey(Company)

    date = models.DateTimeField(auto_now_add=True)
    title = models.CharField(max_length=140)
    description = models.TextField(max_length=500)

    created_at = models.DateTimeField(auto_now_add=True)

    class Meta:
       ordering = ['id']

class Comment(models.Model):
    # forum = models.ForeignKey(Job)
    # user = models.ForeignKey(User)

    title = models.CharField(max_length=140)
    content = models.CharField(max_length=500)

    created_at = models.DateTimeField(auto_now_add=True)

class Application(models.Model):
    # user = models.ForeignKey(User)
    # job = models.ForeignKey(Job)
    status = models.CharField(max_length=140)

    created_at = models.DateTimeField(auto_now_add=True)

frontend/v1/app_company/forms.py
from django import forms

class JobForm(forms.Form):
    title = forms.CharField(max_length=140)
    description = forms.CharField(max_length=500)

frontend/v1/app_company/views.py
from django.shortcuts import render, redirect, reverse
from .models import Company, Job
from .forms import JobForm
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger

response = {}
def index(request):
    response['test'] = 'kons'
    return render(request, 'base.html', response)

def show_profile(request):
    if 'session-id' in request.session:
        return show_profile_by_id(request, request.session['company_id'])
    elif 'dummy-here' in request.session:
        company = Company.objects.get(name="Lorem Ipsum")
        return show_profile_by_id(request, company.id_linkedin)
    else:
        #TODO: Kasih error
        return redirect('/')

def show_profile_by_id(request, key="loremipsum"):
    company = Company.objects.get(id_linkedin=key)
    response['company'] = company
    response['status'] = "company"

    job_list = Job.objects.all().filter(company=company)
    paginator = Paginator(job_list, 3) #TODO: Enak cm 3 doang?

    page = request.GET.get('page')
    try:
        job = paginator.page(page)
    except:
        job = paginator.page(1)

    response['job'] = job
    return render(request, 'compProfile.html', response)


def add_job(request):
    if 'session-id' not in request.session or 'company_id' not in request.session:
        return redirect('/')
    if request.method == 'POST':
        form = JobForm(request.POST)
        response['form'] = form
        if form.is_valid():
            company = Company.objects.filter(id_linkedin=request.session["company_id"]).first()
            Job.objects.create(title=form.cleaned_data['title'],description=form.cleaned_data['description'], company=company)
            return redirect(reverse('company:profile'))
        else:
            job = Job.objects.all()
            response['job'] = job
            response['form'] = form
            return render(request, 'compProfile.html', response)

def delete_job(request, id):
    if 'session-id' not in request.session:
        return redirect('/')
    to_delete = Job.objects.get(id=id)
    to_delete.delete()
    return redirect(reverse('company:profile'))

frontend/v1/app_company/templates/compProfile.html
{% extends "base.html" %}
{% load staticfiles %}
{% load static %}

{% block title %}
Profile Perusahaan
{% endblock %}

{% block css %}
<link rel="stylesheet" type="text/css" href="{% static 'css/company-profile.css' %}" />
{% endblock %}

{% block header %}
{% include "partials/header-company.html" %}
{% endblock %}

{% block content %}
<!-- Judul -->
  <section id="title-section">
    <header>
      <h1 id="company-title">Company Dashboard</h1>
      <p id="company-name">Welcome "{{company.name}}"</p>
    </header>
    <a href="{% url 'app:job-listing'%}" class="btn btn-login">Job List</a>
    <a href="#" class="btn btn-login">Find Student</a>
  </section>

  <div class="container">
    <!-- Section -->
    <section id="about-section">
      <div>
        <!-- 2 Columns -->
        <h2 id="about-company">About Company</h3>
        <div class="row">
          <br>
          <div class="col-md-6">
            <p id="about">{{company.description}}</p>
          </div>
          <div class="col-md-1">

          </div>
          <div class="col-md-5" id="company-details">
            <h5 id="companyType">Company Type: {{company.company_type}}</h5>
            <h5 id="companyWeb">Website: {{company.web}}</h5>
            <h5 id="companySpecialty"><b>Specialities: {{company.specialty}}</h5>
          </div>
        </div>
      </div>
    </section>
</div>
    <section id="posting-job">
      <div class="container">
        <header class="align-center" >
          <h1 class="job-post-title">Create Job Posting</h1>
          <p class="job-post-text">Tell the world your company vacancies.</p>
          <!-- Form for new status -->
          <form class="card-text" method="POST" action="{% url 'company:company-add-job' %}">
            {% csrf_token %}
            <div >
              <input type="text" placeholder="Job title" class="form-control" name="title" id="job-title" title="title"></input>
              <textarea placeholder="Describe your job requirements" class="form-control" name="description" rows="5" id="job-description" title="description"></textarea>
            </div>
            <button type="submit" class="btn btn-login" id="button"> Submit </button>
          </form>
        </header>
      </div>
    </section>

    <section id="job-list">
      <div class="container">
        <h1>Company's Jobs</h1>
        <!-- Print errors if any -->
        {% if form.errors %}
        {% for field in form %}
        {% for error in field.errors %}
        <div class="alert alert-danger">
          <strong>{{ error|escape }}</strong>
        </div>
        {% endfor %}
        {% endfor %}
        {% for error in form.non_field_errors %}
        <div class="alert alert-danger">
          <strong>{{ error|escape }}</strong>
        </div>
        {% endfor %}
        {% endif %}

        <div class="inner">
            <div id="page" class="container">
                <div id="content">
                  <div>
                    {% for i in job reversed %}
                      <nav class="first" id="each-job">
                        <h6 class="card-subtitle mb-2 text-muted"> {{ i.date }} </h6>
                        <p class="card-text" id="each-job-title"> {{ i.title }} </p>
                        <br>
                        <p class="card-text"> {{ i.description }} </p>
                        <div class="row" style="padding-right: 1.5%;">
                          <div class="col-md-10">
                          </div>
                          <div class="col-md-1">
                            {% if is_exist %}
                  					<button class="btn btn-warning" type="submit" disabled>Applied</button>
                    				{% else %}
                    				<form class="" action="{% url 'app:apply-job' i.id %}" method="POST">
                    					{% csrf_token %}
                    					<button class="btn btn-primary" type="submit">Apply Now</button>
                    				</form>
                    				{% endif %}
                          </div>
                          <div class="col-md-1">
                            <b><a href="{% url 'company:company-delete-job' i.id %}" class="btn btn-warning" id="">Delete</a></b>
                          </div>
                        </div>\
                      </nav>
                      <hr>
                    {% endfor %}
                  </div>
                </div>
            </div>
        </div>

        <nav>
          {% if forum.has_other_pages %}
          <ul class="pagination" style="justify-content: center; margin-top: 20px">
            {% if forum.has_previous %}
            <li class="page-item"><a class="page-link" href="?page={{ forum.previous_page_number }}">&laquo;</a></li>
            {% else %}
            <li class="page-item disabled"><span class="page-link">&laquo;</span></li>
            {% endif %}
            {% for i in forum.paginator.page_range %}
            {% if forum.number == i %}
            <li class="page-item active"><span class="page-link">{{ i }} <span class="sr-only">(current)</span></span></li>
            {% else %}
            <li class="page-item"><a class="page-link" href="?page={{ i }}">{{ i }}</a></li>
            {% endif %}
            {% endfor %}
            {% if forum.has_next %}
            <li class="page-item"><a class="page-link" href="?page={{ forum.next_page_number }}">&raquo;</a></li>
            {% else %}
            <li class="page-item disabled"><span class="page-link">&raquo;</span></li>
            {% endif %}
          </ul>
          {% endif %}
        </nav>
      </div>
    </section>

  {% endblock %}

  {% block javascript %}
  {% endblock %}